Index: squid/src/fs/diskd/store_dir_diskd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/diskd/store_dir_diskd.c,v
retrieving revision 1.1.6.1
retrieving revision 1.1.6.2
diff -u -r1.1.6.1 -r1.1.6.2
--- squid/src/fs/diskd/store_dir_diskd.c	2 May 2000 22:50:29 -0000	1.1.6.1
+++ squid/src/fs/diskd/store_dir_diskd.c	14 May 2000 23:22:20 -0000	1.1.6.2
@@ -1639,124 +1523,34 @@
  * uses storeDiskdUnlink() ..
  */
 void
-storeDiskdDirUnlinkFile(SwapDir *SD, sfileno f)
+storeDiskdDirUnlinkFile(SwapDir * SD, sfileno f)
 {
     debug(79, 3) ("storeDiskdDirUnlinkFile: unlinking fileno %08X\n", f);
     storeDiskdDirMapBitReset(SD, f);
     unlinkdUnlink(storeDiskdDirFullPath(SD, f, NULL));
 }
 
-#if !HEAP_REPLACEMENT
-/*
- * storeDiskdDirExpiredReferenceAge
- *
- * The LRU age is scaled exponentially between 1 minute and
- * Config.referenceAge , when store_swap_low < store_swap_size <
- * store_swap_high.  This keeps store_swap_size within the low and high
- * water marks.  If the cache is very busy then store_swap_size stays
- * closer to the low water mark, if it is not busy, then it will stay
- * near the high water mark.  The LRU age value can be examined on the
- * cachemgr 'info' page.
- */
-static time_t
-storeDiskdDirExpiredReferenceAge(SwapDir *SD)
-{
-    double x;
-    double z;
-    time_t age;
-    long store_high, store_low;
- 
-    store_high = (long) (((float) SD->max_size *
-            (float) Config.Swap.highWaterMark) / (float) 100);
-    store_low = (long) (((float) SD->max_size *
-            (float) Config.Swap.lowWaterMark) / (float) 100);
-    debug(20, 20) ("RA: Dir %s, hi=%d, lo=%d, cur=%d\n", SD->path, store_high, store_low, SD->cur_size);
-  
-    x = (double) (store_high - SD->cur_size) /
-        (store_high - store_low);
-    x = x < 0.0 ? 0.0 : x > 1.0 ? 1.0 : x;
-    z = pow((double) (Config.referenceAge / 60), x);
-    age = (time_t) (z * 60.0);
-    if (age < 60)
-        age = 60;
-    else if (age > Config.referenceAge)
-        age = Config.referenceAge;
-    return age;
-}
-#endif
-
-/*
- * storeDiskdDirCheckExpired
- *
- * Check whether the given object is expired or not
- * It breaks layering a little by calling the upper layers to find
- * out whether the object is locked or not, but we can't help this
- * right now.
- */
-static int
-storeDiskdDirCheckExpired(SwapDir *SD, StoreEntry *e)
-{
-    if (storeEntryLocked(e))
-       return 0;
-    if (EBIT_TEST(e->flags, RELEASE_REQUEST))
-       return 1;
-    if (EBIT_TEST(e->flags, ENTRY_NEGCACHED) && squid_curtime >= e->expires)
-       return 1;
-
-#if HEAP_REPLACEMENT
-    /*
-     * with HEAP_REPLACEMENT we are not using the LRU reference age, the heap
-     * controls the replacement of objects.
-     */
-    return 1;
-#else
-    if (squid_curtime - e->lastref > storeDiskdDirExpiredReferenceAge(SD))
-       return 1;
-    return 0;
-#endif
-}
-
 /*
  * Add and remove the given StoreEntry from the replacement policy in
  * use.
  */
 
 void
-storeDiskdDirReplAdd(SwapDir *SD, StoreEntry *e)
+storeDiskdDirReplAdd(SwapDir * SD, StoreEntry * e)
 {
     debug(20, 4) ("storeDiskdDirReplAdd: added node %p to dir %d\n", e,
-      SD->index);
-#if HEAP_REPLACEMENT
-    if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-        (void) 0;
-    } else {
-        e->repl.node = heap_insert(SD->repl.heap.heap, e);
-        debug(20, 4) ("storeDiskdDirReplAdd: inserted node 0x%x\n", e->repl.node);
-    }
-#else
-    /* Shouldn't we not throw special objects into the lru ? */
-    dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
-#endif
+	SD->index);
+    SD->repl->Add(SD->repl, e, &e->repl);
 }
 
 
 void
-storeDiskdDirReplRemove(StoreEntry *e)
+storeDiskdDirReplRemove(StoreEntry * e)
 {
     SwapDir *SD = INDEXSD(e->swap_dirn);
     debug(20, 4) ("storeDiskdDirReplRemove: remove node %p from dir %d\n", e,
-      SD->index);
-#if HEAP_REPLACEMENT
-    /* And now, release the object from the replacement policy */
-    if (e->repl.node) {
-        debug(20, 4) ("storeDiskdDirReplRemove: deleting node 0x%x\n",
-          e->repl.node);
-        heap_delete(SD->repl.heap.heap, e->repl.node);
-        e->repl.node = NULL;
-    }
-#else
-    dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
-#endif
+	SD->index);
+    SD->repl->Remove(SD->repl, e, &e->repl);
 }
 
 
@@ -1769,7 +1563,7 @@
 storeDiskdShmGet(SwapDir * sd, int *shm_offset)
 {
     char *buf;
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     buf = linklistShift(&diskdinfo->shm.stack);
     assert(buf);
     *shm_offset = buf - diskdinfo->shm.buf;
@@ -1782,7 +1576,7 @@
 storeDiskdShmPut(SwapDir * sd, int offset)
 {
     char *buf;
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     assert(offset >= 0);
     assert(offset < SHMBUFS * SHMBUF_BLKSZ);
     buf = diskdinfo->shm.buf + offset;
@@ -1796,51 +1590,51 @@
 /* ========== LOCAL FUNCTIONS ABOVE, GLOBAL FUNCTIONS BELOW ========== */
 
 void
-storeDiskdDirStats(SwapDir *SD, StoreEntry * sentry)
+storeDiskdDirStats(SwapDir * SD, StoreEntry * sentry)
 {
     diskdinfo_t *diskdinfo;
 #if HAVE_STATVFS
     struct statvfs sfs;
 #endif
-    diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo = (diskdinfo_t *) SD->fsdata;
     storeAppendPrintf(sentry, "First level subdirectories: %d\n", diskdinfo->l1);
     storeAppendPrintf(sentry, "Second level subdirectories: %d\n", diskdinfo->l2);
     storeAppendPrintf(sentry, "Maximum Size: %d KB\n", SD->max_size);
     storeAppendPrintf(sentry, "Current Size: %d KB\n", SD->cur_size);
     storeAppendPrintf(sentry, "Percent Used: %0.2f%%\n",
-        100.0 * SD->cur_size / SD->max_size);
+	100.0 * SD->cur_size / SD->max_size);
     storeAppendPrintf(sentry, "Filemap bits in use: %d of %d (%d%%)\n",
-    diskdinfo->map->n_files_in_map, diskdinfo->map->max_n_files,
-    percent(diskdinfo->map->n_files_in_map, diskdinfo->map->max_n_files));
+	diskdinfo->map->n_files_in_map, diskdinfo->map->max_n_files,
+	percent(diskdinfo->map->n_files_in_map, diskdinfo->map->max_n_files));
 #if HAVE_STATVFS
 #define fsbtoblk(num, fsbs, bs) \
     (((fsbs) != 0 && (fsbs) < (bs)) ? \
             (num) / ((bs) / (fsbs)) : (num) * ((fsbs) / (bs)))
-	if (!statvfs(SD->path, &sfs)) {
-            storeAppendPrintf(sentry, "Filesystem Space in use: %d/%d KB (%d%%)\n",
-            fsbtoblk((sfs.f_blocks - sfs.f_bfree), sfs.f_frsize, 1024),
-            fsbtoblk(sfs.f_blocks, sfs.f_frsize, 1024),
-            percent(sfs.f_blocks - sfs.f_bfree, sfs.f_blocks));
-            storeAppendPrintf(sentry, "Filesystem Inodes in use: %d/%d (%d%%)\n",
-            sfs.f_files - sfs.f_ffree, sfs.f_files,
-            percent(sfs.f_files - sfs.f_ffree, sfs.f_files));
+    if (!statvfs(SD->path, &sfs)) {
+	storeAppendPrintf(sentry, "Filesystem Space in use: %d/%d KB (%d%%)\n",
+	    fsbtoblk((sfs.f_blocks - sfs.f_bfree), sfs.f_frsize, 1024),
+	    fsbtoblk(sfs.f_blocks, sfs.f_frsize, 1024),
+	    percent(sfs.f_blocks - sfs.f_bfree, sfs.f_blocks));
+	storeAppendPrintf(sentry, "Filesystem Inodes in use: %d/%d (%d%%)\n",
+	    sfs.f_files - sfs.f_ffree, sfs.f_files,
+	    percent(sfs.f_files - sfs.f_ffree, sfs.f_files));
     }
 #endif
     storeAppendPrintf(sentry, "Flags:");
     if (SD->flags.selected)
-        storeAppendPrintf(sentry, " SELECTED");
+	storeAppendPrintf(sentry, " SELECTED");
     if (SD->flags.read_only)
-        storeAppendPrintf(sentry, " READ-ONLY");
+	storeAppendPrintf(sentry, " READ-ONLY");
     storeAppendPrintf(sentry, "\n");
+#if OLD_UNUSED_CODE
 #if !HEAP_REPLACEMENT
     storeAppendPrintf(sentry, "LRU Expiration Age: %6.2f days\n",
-      (double) storeDiskdDirExpiredReferenceAge(SD) / 86400.0); 
+	(double) storeDiskdDirExpiredReferenceAge(SD) / 86400.0);
 #else
-#if 0
     storeAppendPrintf(sentry, "Storage Replacement Threshold:\t%f\n",
-        heap_peepminkey(sd.repl.heap.heap));
-#endif
+	heap_peepminkey(sd.repl.heap.heap));
 #endif
+#endif /* OLD_UNUSED_CODE */
     storeAppendPrintf(sentry, "Pending operations: %d\n", diskdinfo->away);
 }
 
@@ -1850,7 +1644,7 @@
  * This routine is called when the given swapdir needs reconfiguring 
  */
 void
-storeDiskdDirReconfigure(SwapDir *sd, int index, char *path)
+storeDiskdDirReconfigure(SwapDir * sd, int index, char *path)
 {
     char *token;
     int i;
@@ -1896,7 +1690,7 @@
     if (sd->flags.read_only != read_only)
 	debug(3, 1) ("Cache dir '%s' now %s\n",
 	    path, read_only ? "Read-Only" : "Read-Write");
-    diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo = (diskdinfo_t *) sd->fsdata;
     diskdinfo->magic1 = magic1;
     diskdinfo->magic2 = magic2;
     sd->flags.read_only = read_only;
@@ -1906,10 +1700,10 @@
 void
 storeDiskdDirDump(StoreEntry * entry, const char *name, SwapDir * s)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)s->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) s->fsdata;
     storeAppendPrintf(entry, "%s %s %s %d %d %d\n",
 	name,
-        "diskd",
+	"diskd",
 	s->path,
 	s->max_size >> 10,
 	diskdinfo->l1,
@@ -1922,22 +1716,22 @@
 static void
 storeDiskdDirFree(SwapDir * s)
 {
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)s->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) s->fsdata;
     if (diskdinfo->swaplog_fd > -1) {
 	file_close(diskdinfo->swaplog_fd);
 	diskdinfo->swaplog_fd = -1;
     }
     filemapFreeMemory(diskdinfo->map);
     xfree(diskdinfo);
-    s->fsdata = NULL; /* Will aid debugging... */
+    s->fsdata = NULL;		/* Will aid debugging... */
 
 }
 
 char *
-storeDiskdDirFullPath(SwapDir *SD, sfileno filn, char *fullpath)
+storeDiskdDirFullPath(SwapDir * SD, sfileno filn, char *fullpath)
 {
     LOCAL_ARRAY(char, fullfilename, SQUID_MAXPATHLEN);
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) SD->fsdata;
     int L1 = diskdinfo->l1;
     int L2 = diskdinfo->l2;
     if (!fullpath)
@@ -1957,28 +1751,28 @@
  * This is called by storeCleanup() if -S was given on the command line.
  */
 static int
-storeDiskdCleanupDoubleCheck(SwapDir *sd, StoreEntry *e)
+storeDiskdCleanupDoubleCheck(SwapDir * sd, StoreEntry * e)
 {
     struct stat sb;
 
     if (stat(storeDiskdDirFullPath(sd, e->swap_filen, NULL), &sb) < 0) {
-        debug(20, 0) ("storeDiskdCleanupDoubleCheck: MISSING SWAP FILE\n");
-        debug(20, 0) ("storeDiskdCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
-        debug(20, 0) ("storeDiskdCleanupDoubleCheck: PATH %s\n",
-            storeDiskdDirFullPath(sd, e->swap_filen, NULL));
-        storeEntryDump(e, 0);
-        return -1;
-    }       
+	debug(20, 0) ("storeDiskdCleanupDoubleCheck: MISSING SWAP FILE\n");
+	debug(20, 0) ("storeDiskdCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
+	debug(20, 0) ("storeDiskdCleanupDoubleCheck: PATH %s\n",
+	    storeDiskdDirFullPath(sd, e->swap_filen, NULL));
+	storeEntryDump(e, 0);
+	return -1;
+    }
     if (e->swap_file_sz != sb.st_size) {
-        debug(20, 0) ("storeDiskdCleanupDoubleCheck: SIZE MISMATCH\n");
-        debug(20, 0) ("storeDiskdCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
-        debug(20, 0) ("storeDiskdCleanupDoubleCheck: PATH %s\n",
-            storeDiskdDirFullPath(sd, e->swap_filen, NULL));
-        debug(20, 0) ("storeDiskdCleanupDoubleCheck: ENTRY SIZE: %d, FILE SIZE: %d\n",
-            e->swap_file_sz, (int) sb.st_size); 
-        storeEntryDump(e, 0); 
-        return -1;
-    }       
+	debug(20, 0) ("storeDiskdCleanupDoubleCheck: SIZE MISMATCH\n");
+	debug(20, 0) ("storeDiskdCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
+	debug(20, 0) ("storeDiskdCleanupDoubleCheck: PATH %s\n",
+	    storeDiskdDirFullPath(sd, e->swap_filen, NULL));
+	debug(20, 0) ("storeDiskdCleanupDoubleCheck: ENTRY SIZE: %d, FILE SIZE: %d\n",
+	    e->swap_file_sz, (int) sb.st_size);
+	storeEntryDump(e, 0);
+	return -1;
+    }
     return 0;
 }
 
@@ -1988,7 +1782,7 @@
  * Called when a *new* fs is being setup.
  */
 void
-storeDiskdDirParse(SwapDir *sd, int index, char *path)
+storeDiskdDirParse(SwapDir * sd, int index, char *path)
 {
     char *token;
     int i;
@@ -2027,7 +1821,7 @@
 
     diskdinfo = xmalloc(sizeof(diskdinfo_t));
     if (diskdinfo == NULL)
-        fatal("storeDiskdDirParse: couldn't xmalloc() diskdinfo_t!\n");
+	fatal("storeDiskdDirParse: couldn't xmalloc() diskdinfo_t!\n");
 
     sd->index = index;
     sd->path = xstrdup(path);
@@ -2036,7 +1830,7 @@
     diskdinfo->l1 = l1;
     diskdinfo->l2 = l2;
     diskdinfo->swaplog_fd = -1;
-    diskdinfo->map = NULL; /* Debugging purposes */
+    diskdinfo->map = NULL;	/* Debugging purposes */
     diskdinfo->suggest = 0;
     diskdinfo->magic1 = magic1;
     diskdinfo->magic2 = magic2;
@@ -2062,41 +1856,12 @@
     sd->log.open = storeDiskdDirOpenSwapLog;
     sd->log.close = storeDiskdDirCloseSwapLog;
     sd->log.write = storeDiskdDirSwapLog;
-    sd->log.clean.open = storeDiskdDirWriteCleanOpen;
+    sd->log.clean.start = storeDiskdDirWriteCleanStart;
+    sd->log.clean.nextentry = storeDiskdDirCleanLogNextEntry;
+    sd->log.clean.done = storeDiskdDirWriteCleanDone;
 
     /* Initialise replacement policy stuff */
-#if HEAP_REPLACEMENT
-    /*
-     * Create new heaps with cache replacement policies attached to them.
-     * The cache replacement policy is specified as either GDSF or LFUDA in
-     * the squid.conf configuration file.  Note that the replacement policy
-     * applies only to the disk replacement algorithm.  Memory replacement
-     * always uses GDSF since we want to maximize object hit rate.
-     */
-    if (Config.replPolicy) {
-        if (tolower(Config.replPolicy[0]) == 'g') {
-            debug(20, 1) ("Using GDSF disk replacement policy\n");
-            sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_GDSF);
-        } else if (tolower(Config.replPolicy[0]) == 'l') {
-            if (tolower(Config.replPolicy[1]) == 'f') {
-                debug(20, 1) ("Using LFUDA disk replacement policy\n");
-                sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_LFUDA);
-            } else if (tolower(Config.replPolicy[1]) == 'r') {
-                debug(20, 1) ("Using LRU heap disk replacement policy\n");
-                sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_LRU);
-            }
-        } else {
-            debug(20, 1) ("Unrecognized replacement_policy; using GDSF\n");
-            sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_GDSF);
-        }
-    } else {
-        debug(20, 1) ("Using default disk replacement policy (GDSF)\n");
-        sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_GDSF);
-    }
-#else
-    sd->repl.lru.list.head = NULL;
-    sd->repl.lru.list.tail = NULL;
-#endif
+    sd->repl = createRemovalPolicy(Config.replPolicy);
 }
 
 /*
@@ -2110,7 +1875,7 @@
 }
 
 void
-storeFsSetup_diskd(storefs_entry_t *storefs)
+storeFsSetup_diskd(storefs_entry_t * storefs)
 {
     assert(!diskd_initialised);
     storefs->parsefunc = storeDiskdDirParse;
@@ -2122,4 +1887,3 @@
     debug(81, 1) ("diskd started\n");
     diskd_initialised = 1;
 }
-
Index: squid/src/fs/diskd/store_diskd.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/diskd/store_diskd.h,v
retrieving revision 1.1.6.1
retrieving revision 1.1.6.2
diff -u -r1.1.6.1 -r1.1.6.2
--- squid/src/fs/diskd/store_diskd.h	2 May 2000 22:50:29 -0000	1.1.6.1
+++ squid/src/fs/diskd/store_diskd.h	14 May 2000 23:22:20 -0000	1.1.6.2
@@ -82,17 +82,18 @@
 static const int msg_snd_rcv_sz = sizeof(diomsg) - sizeof(mtyp_t);
 
 /* The diskd_state memory pool */
-extern MemPool * diskd_state_pool;
+extern MemPool *diskd_state_pool;
 
 extern void storeDiskdDirMapBitReset(SwapDir *, sfileno);
 extern int storeDiskdDirMapBitAllocate(SwapDir *);
-extern char * storeDiskdDirFullPath(SwapDir *SD, sfileno filn, char *fullpath);
+extern char *storeDiskdDirFullPath(SwapDir * SD, sfileno filn, char *fullpath);
 extern void storeDiskdDirUnlinkFile(SwapDir *, sfileno);
 extern void storeDiskdDirReplAdd(SwapDir *, StoreEntry *);
 extern void storeDiskdDirReplRemove(StoreEntry *);
 extern void storeDiskdShmPut(SwapDir *, int);
 extern void *storeDiskdShmGet(SwapDir *, int *);
-extern void storeDiskdHandle(diomsg *M);
+extern void storeDiskdHandle(diomsg * M);
+extern void storeDiskdDirCallback(SwapDir *);
 
 
 /*
Index: squid/src/fs/diskd/store_io_diskd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/diskd/store_io_diskd.c,v
retrieving revision 1.1.6.1
retrieving revision 1.1.6.2
diff -u -r1.1.6.1 -r1.1.6.2
--- squid/src/fs/diskd/store_io_diskd.c	2 May 2000 22:50:29 -0000	1.1.6.1
+++ squid/src/fs/diskd/store_io_diskd.c	14 May 2000 23:22:20 -0000	1.1.6.2
@@ -31,8 +31,8 @@
 /* === PUBLIC =========================================================== */
 
 storeIOState *
-storeDiskdOpen(SwapDir *SD, StoreEntry *e, STFNCB *file_callback,
-  STIOCB *callback, void *callback_data)
+storeDiskdOpen(SwapDir * SD, StoreEntry * e, STFNCB * file_callback,
+    STIOCB * callback, void *callback_data)
 {
     sfileno f = e->swap_filen;
     int x;
@@ -46,7 +46,7 @@
      * If there are too many requests queued.
      */
     if (diskdinfo->away > diskdinfo->magic1) {
-        debug(81, 3) ("storeDiskdOpen: FAILING, too many requests away\n");
+	debug(81, 3) ("storeDiskdOpen: FAILING, too many requests away\n");
 	diskd_stats.open_fail_queue_len++;
 	return NULL;
     }
@@ -62,17 +62,17 @@
     sio->e = e;
     cbdataLock(callback_data);
 
-    ((diskdstate_t *)(sio->fsstate))->flags.writing = 0;
-    ((diskdstate_t *)(sio->fsstate))->flags.reading = 0;
-    ((diskdstate_t *)(sio->fsstate))->flags.close_request = 0;
-    ((diskdstate_t *)(sio->fsstate))->id = diskd_stats.sio_id++;
+    ((diskdstate_t *) (sio->fsstate))->flags.writing = 0;
+    ((diskdstate_t *) (sio->fsstate))->flags.reading = 0;
+    ((diskdstate_t *) (sio->fsstate))->flags.close_request = 0;
+    ((diskdstate_t *) (sio->fsstate))->id = diskd_stats.sio_id++;
 
     buf = storeDiskdShmGet(SD, &shm_offset);
     /* XXX WRONG!!! :) */
     strcpy(buf, storeDiskdDirFullPath(SD, f, NULL));
     x = storeDiskdSend(_MQD_OPEN,
 	SD,
-	((diskdstate_t *)(sio->fsstate))->id,
+	((diskdstate_t *) (sio->fsstate))->id,
 	sio,
 	strlen(buf) + 1,
 	O_RDONLY,
@@ -88,8 +88,8 @@
 }
 
 storeIOState *
-storeDiskdCreate(SwapDir *SD, StoreEntry *e, STFNCB *file_callback,
-  STIOCB *callback, void *callback_data)
+storeDiskdCreate(SwapDir * SD, StoreEntry * e, STFNCB * file_callback,
+    STIOCB * callback, void *callback_data)
 {
     sfileno f;
     int x;
@@ -105,7 +105,6 @@
 	diskd_stats.open_fail_queue_len++;
 	return NULL;
     }
-
     /* Allocate a number */
     f = storeDiskdDirMapBitAllocate(SD);
     debug(81, 3) ("storeDiskdCreate: fileno %08X\n", f);
@@ -122,17 +121,17 @@
     sio->e = e;
     cbdataLock(callback_data);
 
-    ((diskdstate_t *)(sio->fsstate))->flags.writing = 0;
-    ((diskdstate_t *)(sio->fsstate))->flags.reading = 0;
-    ((diskdstate_t *)(sio->fsstate))->flags.close_request = 0;
-    ((diskdstate_t *)(sio->fsstate))->id = diskd_stats.sio_id++;
+    ((diskdstate_t *) (sio->fsstate))->flags.writing = 0;
+    ((diskdstate_t *) (sio->fsstate))->flags.reading = 0;
+    ((diskdstate_t *) (sio->fsstate))->flags.close_request = 0;
+    ((diskdstate_t *) (sio->fsstate))->id = diskd_stats.sio_id++;
 
     buf = storeDiskdShmGet(SD, &shm_offset);
     /* XXX WRONG!!! :) */
     strcpy(buf, storeDiskdDirFullPath(SD, f, NULL));
     x = storeDiskdSend(_MQD_OPEN,
 	SD,
-	((diskdstate_t *)(sio->fsstate))->id,
+	((diskdstate_t *) (sio->fsstate))->id,
 	sio,
 	strlen(buf) + 1,
 	sio->mode,
@@ -150,12 +149,12 @@
 
 
 void
-storeDiskdClose(SwapDir *SD, storeIOState * sio)
+storeDiskdClose(SwapDir * SD, storeIOState * sio)
 {
     int x;
-    diskdstate_t *diskdstate = (diskdstate_t *)sio->fsstate;
+    diskdstate_t *diskdstate = (diskdstate_t *) sio->fsstate;
     debug(81, 3) ("storeDiskdClose: dirno %d, fileno %08X\n", SD->index,
-      sio->swap_filen);
+	sio->swap_filen);
     x = storeDiskdSend(_MQD_CLOSE,
 	SD,
 	diskdstate->id,
@@ -170,12 +169,12 @@
 }
 
 void
-storeDiskdRead(SwapDir *SD, storeIOState * sio, char *buf, size_t size, off_t offset, STRCB * callback, void *callback_data)
+storeDiskdRead(SwapDir * SD, storeIOState * sio, char *buf, size_t size, off_t offset, STRCB * callback, void *callback_data)
 {
     int x;
     int shm_offset;
     char *rbuf;
-    diskdstate_t *diskdstate = (diskdstate_t *)sio->fsstate;
+    diskdstate_t *diskdstate = (diskdstate_t *) sio->fsstate;
     if (!cbdataValid(sio))
 	return;
     if (diskdstate->flags.reading) {
@@ -208,12 +207,12 @@
 }
 
 void
-storeDiskdWrite(SwapDir *SD, storeIOState * sio, char *buf, size_t size, off_t offset, FREE * free_func)
+storeDiskdWrite(SwapDir * SD, storeIOState * sio, char *buf, size_t size, off_t offset, FREE * free_func)
 {
     int x;
     char *sbuf;
     int shm_offset;
-    diskdstate_t *diskdstate = (diskdstate_t *)sio->fsstate;
+    diskdstate_t *diskdstate = (diskdstate_t *) sio->fsstate;
     debug(81, 3) ("storeDiskdWrite: dirno %d, fileno %08X\n", SD->index, sio->swap_filen);
     if (!cbdataValid(sio)) {
 	free_func(buf);
@@ -223,7 +222,7 @@
     sbuf = storeDiskdShmGet(SD, &shm_offset);
     xmemcpy(sbuf, buf, size);
     if (free_func)
-        free_func(buf);
+	free_func(buf);
     x = storeDiskdSend(_MQD_WRITE,
 	SD,
 	diskdstate->id,
@@ -239,24 +238,23 @@
 }
 
 void
-storeDiskdUnlink(SwapDir *SD, StoreEntry *e)
+storeDiskdUnlink(SwapDir * SD, StoreEntry * e)
 {
     int x;
     int shm_offset;
     char *buf;
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)SD->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) SD->fsdata;
 
     debug(81, 3) ("storeDiskdUnlink: dirno %d, fileno %08X\n", SD->index,
-      e->swap_filen);
+	e->swap_filen);
     storeDiskdDirReplRemove(e);
     storeDiskdDirMapBitReset(SD, e->swap_filen);
     if (diskdinfo->away >= diskdinfo->magic1) {
-        /* Damn, we need to issue a sync unlink here :( */
-        debug(50, 2) ("storeDiskUnlink: Out of queue space, sync unlink\n");
-        storeDiskdDirUnlinkFile(SD, e->swap_filen);
-        return;
+	/* Damn, we need to issue a sync unlink here :( */
+	debug(50, 2) ("storeDiskUnlink: Out of queue space, sync unlink\n");
+	storeDiskdDirUnlinkFile(SD, e->swap_filen);
+	return;
     }
-
     /* We can attempt a diskd unlink */
     buf = storeDiskdShmGet(SD, &shm_offset);
     strcpy(buf, storeDiskdDirFullPath(SD, e->swap_filen, NULL));
@@ -269,7 +267,7 @@
 	shm_offset);
     if (x < 0) {
 	debug(50, 1) ("storeDiskdSend UNLINK: %s\n", xstrerror());
-	unlink(buf); /* XXX EWW! */
+	unlink(buf);		/* XXX EWW! */
 	storeDiskdShmPut(SD, shm_offset);
     }
 }
@@ -342,7 +340,7 @@
 storeDiskdWriteDone(diomsg * M)
 {
     storeIOState *sio = M->callback_data;
-    diskdstate_t *diskdstate = (diskdstate_t *)sio->fsstate;
+    diskdstate_t *diskdstate = (diskdstate_t *) sio->fsstate;
     Counter.syscalls.disk.writes++;
     diskdstate->flags.writing = 0;
     debug(81, 3) ("storeDiskdWriteDone: dirno %d, fileno %08x status %d\n",
@@ -423,7 +421,7 @@
     static int send_errors = 0;
     static int last_seq_no = 0;
     static int seq_no = 0;
-    diskdinfo_t *diskdinfo = (diskdinfo_t *)sd->fsdata;
+    diskdinfo_t *diskdinfo = (diskdinfo_t *) sd->fsdata;
     M.mtype = mtype;
     M.callback_data = sio;
     M.size = size;
@@ -447,6 +445,13 @@
 	    cbdataUnlock(M.callback_data);
 	assert(++send_errors < 100);
     }
+    /*
+     * We have to drain the queue here if necessary.  If we don't,
+     * then we can have a lot of messages in the queue (probably
+     * up to 2*magic1) and we can run out of shared memory buffers.
+     */
+    if (diskdinfo->away > diskdinfo->magic2)
+	storeDiskdDirCallback(sd);
     return x;
 }
 
@@ -458,7 +463,6 @@
 static void
 storeDiskdIOFreeEntry(void *sio, int foo)
 {
-    memPoolFree(diskd_state_pool, ((storeIOState *)sio)->fsstate);
+    memPoolFree(diskd_state_pool, ((storeIOState *) sio)->fsstate);
     memFree(sio, MEM_STORE_IO);
 }
-
